
from langchain_community.chat_models.mlflow import ChatMlflow
from mlflow.deployments import get_deploy_client
from fairo.settings import get_mlflow_gateway_chat_route, get_mlflow_gateway_uri, get_mlflow_user, get_mlflow_password
import os


class ChatFairo(ChatMlflow):

    def __init__(self, **kwargs):

        # # TODO <- see if this can be improved
        # os.environ["MLFLOW_TRACKING_USERNAME"] = get_mlflow_user()
        # os.environ["MLFLOW_TRACKING_PASSWORD"] = get_mlflow_password()

        super().__init__(
            target_uri=os.environ.get('MLFLOW_GATEWAY_URI', get_mlflow_gateway_uri()),
            endpoint=os.environ.get('MLFLOW_GATEWAY_ROUTE', get_mlflow_gateway_chat_route()),
            **kwargs
        )

    @property
    def _target_uri(self):
        return os.environ.get("MLFLOW_GATEWAY_URI", None)

    @property
    def _endpoint(self):
        return os.environ.get("MLFLOW_GATEWAY_ROUTE", None)

    def invoke(self, *args, **kwargs):
        # Override invoke to use dynamic target_uri
        self.target_uri = self._target_uri
        self._client = get_deploy_client(self.target_uri)
        return super().invoke(*args, **kwargs)


class FairoChat(ChatMlflow):
    def __init__(self, endpoint, **kwargs):
        super().__init__(
            target_uri=os.environ.get('MLFLOW_GATEWAY_URI', None),
            endpoint=endpoint,
            # extra_params={"workflow_run_id": workflow_run_id},
            **kwargs
        )

    @property
    def _target_uri(self):
        return os.environ.get("MLFLOW_GATEWAY_URI", None)
    
    def invoke(self, *args, **kwargs):
        # Override invoke to use dynamic target_uri
        self.target_uri = self._target_uri
        self._client = get_deploy_client(self.target_uri)
        return super().invoke(*args, **kwargs)